/**
* DevExtreme (exporter/excel/excel.doc_comments.d.ts)
* Version: 19.2.9 (build 20226-1038)
* Build date: Thu Aug 13 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    dxDataGridColumn
} from '../../ui/data_grid';

/** Warning! This type is used for internal purposes. Do not import it directly. */
export interface ExcelDataGridCell {
    /** The configuration of the cell's column. */
    column?: dxDataGridColumn;
    /** The data object of the cell's row. */
    data?: any;
    /** The group index of the cell's row. Available when the rowType is "group". */
    groupIndex?: number;
    /** Information about group summary items the cell represents. */
    groupSummaryItems?: Array<{ name?: string, value?: any }>;
    /** The type of the cell's row. */
    rowType?: string;
    /** The identifier of the total summary item that the cell represents. */
    totalSummaryItemName?: string;
    /** The cell's raw value. */
    value?: any;
}

/** Warning! This type is used for internal purposes. Do not import it directly. */
export interface ExcelFont {
    /** Specifies whether the text should be in bold. */
    bold?: boolean;
    /** The text's color in hexadecimal characters. */
    color?: string;
    /** Specifies whether the text should be in italic. */
    italic?: boolean;
    /** The name of the typeface that should be applied to the text. */
    name?: string;
    /** The font size specified in points (1/72 of an inch). */
    size?: number;
    /** The underline formatting style. */
    underline?: 'double' | 'doubleAccounting' | 'none' | 'single' | 'singleAccounting';
}
