/**
* DevExtreme (ui/file_manager/file_provider/remote.d.ts)
* Version: 19.2.9 (build 20226-1038)
* Build date: Thu Aug 13 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import FileProvider, {
    FileProviderOptions
} from './file_provider';

/** Warning! This type is used for internal purposes. Do not import it directly. */
export interface RemoteFileProviderOptions extends FileProviderOptions<RemoteFileProvider> {
    /** Specifies the URL of an endpoint used to access and modify a file system located on the server. */
    endpointUrl?: string;
    /** Specifies which data field provides information about whether a directory has subdirectories. */
    hasSubDirectoriesExpr?: string | Function;
}
/** The Remote file provider works with a file system located on the server. */
export default class RemoteFileProvider extends FileProvider {
    constructor(options?: RemoteFileProviderOptions)
}
